import { Entity } from '../core';

import { Render } from '../components';
import { Transform } from '../components';

const vertices = [
  0.5, 0.5, 0.5,
  0.5, 0.5, -0.5,
  0.5, -0.5, 0.5,
  0.5, -0.5, -0.5,
  -0.5, 0.5, -0.5,
  -0.5, 0.5, 0.5,
  -0.5, -0.5, -0.5,
  -0.5, -0.5, 0.5,
  -0.5, 0.5, -0.5,
  0.5, 0.5, -0.5,
  -0.5, 0.5, 0.5,
  0.5, 0.5, 0.5,
  -0.5, -0.5, 0.5,
  0.5, -0.5, 0.5,
  -0.5, -0.5, -0.5,
  0.5, -0.5, -0.5,
  -0.5, 0.5, 0.5,
  0.5, 0.5, 0.5,
  -0.5, -0.5, 0.5,
  0.5, -0.5, 0.5,
  0.5, 0.5, -0.5,
  -0.5, 0.5, -0.5,
  0.5, -0.5, -0.5,
  -0.5, -0.5, -0.5
];

const indices = [
  0, 2, 1,
  2, 3, 1,
  4, 6, 5,
  6, 7, 5,
  8, 10, 9,
  10, 11, 9,
  12, 14, 13,
  14, 15, 13,
  16, 18, 17,
  18, 19, 17,
  20, 22, 21,
  22, 23, 21
];

const normals = [
  1, 0, 0,
  1, 0, 0,
  1, 0, 0,
  1, 0, 0,
  -1, 0, 0,
  -1, 0, 0,
  -1, 0, 0,
  -1, 0, 0,
  0, 1, 0,
  0, 1, 0,
  0, 1, 0,
  0, 1, 0,
  0, -1, 0,
  0, -1, 0,
  0, -1, 0,
  0, -1, 0,
  0, 0, 1,
  0, 0, 1,
  0, 0, 1,
  0, 0, 1,
  0, 0, -1,
  0, 0, -1,
  0, 0, -1,
  0, 0, -1
];

const uvs = [
  0, 0,
  1, 0,
  0, 1,
  1, 1,

  0, 0,
  1, 0,
  0, 1,
  1, 1,

  0, 0,
  1, 0,
  0, 1,
  1, 1,

  0, 0,
  1, 0,
  0, 1,
  1, 1,

  0, 0,
  1, 0,
  0, 1,
  1, 1,

  0, 0,
  1, 0,
  0, 1,
  1, 1,

];

export class Box extends Entity {
  constructor(options = {}) {
    options.components = [
      new Transform(),
      new Render({
        vertices,
        indices,
        normals,
        material: options.material,
        uvs
      })
    ];

    super(options);
  }
}
